//For expf()
#include "TrackBall.h"
#include <GL/freeglut.h>									//GLUT library
#include "include/Quad.h"										//the Quad class definition
#include "include/Point3d.h"
#include <math.h>
#include <stdio.h>
#define M_PI 3.14159265358979323846
/// Return the maximum of a or b
#define FXMAX(a,b)         (((a)>(b))?(a):(b))

/// Return the minimum of a or b
#define FXMIN(a,b)         (((a)>(b))?(b):(a))

/// Return the minimum of x, y and z
#define FXMIN3(x,y,z)      ((x)<(y)?FXMIN(x,z):FXMIN(y,z))
Trackball m_ball;

/// Return the maximum of x, y and z
#define FXMAX3(x,y,z)      ((x)>(y)?FXMAX(x,z):FXMAX(y,z))
float Xmin	= -100.5, Xmax	= 100.5;							//Range of variable x that we sample
float Ymin	= -100.5, Ymax	=100.5;							//Range of variable y that we sample
float Zmin	= 1000, Zmax	= -1000;							//Range of variable y that we sample
int   Nx	= 600, Ny	= 600;							//Number of samples taken along the x and y axes

float dx = (Xmax-Xmin)/(Nx-1);							//Size of a cell along the x axis
float dy = (Ymax-Ymin)/(Ny-1);							//Size of a cell along the y axis


float fov	 = 60;										//Perspective projection parameters
int N=10;
float c_x   = 0,  c_y   = 0,  c_z   = 0;
int winW=500;
int winH=500;
float R=1.0;
float f(float x, float y)								//A simple two-variable function to plot
{														//The function is samples
	//float ret = 10*cos(10*(double)y*2*M_PI/(Ymax-Ymin));
	float ret = sin((x-c_x)/20)*expf(-((x-c_x)*(x-c_x)+(y-c_y)*(y-c_y))/sqrt((Ymax-Ymin)*(Ymax-Ymin)+(Ymax-Ymin)*(Ymax-Ymin)));
	return ret;// *sin(ret / 20 / PI);
}
float potential(float x, float y, float z)
{
	///itvleba potenciali fi
	float phi = 0.0;
	return phi;
}
void calcZminmax()
{
	for(float x=Xmin;x<=Xmax-dx;x+=dx)					//2. Render the height plot as a set of quads
		for(float y=Ymin;y<=Ymax-dy;y+=dy)
		{
			float tmp= f(x,y);
			Zmax=FXMAX(Zmax,tmp);
			Zmin=FXMIN(Zmin,tmp);

		}
}
float getboundingR()
{
	calcZminmax();
	c_x=0.5*(Xmin+Xmax);
	c_y=0.5*(Ymin+Ymax);
	c_z=0.5*(Zmin+Zmax);
	double dx=Xmax-Xmin;
	double dy=Ymax-Ymin;
	double dz=Zmax-Zmin;
	double tmpmax=FXMAX3(dx,dy,dz);
	return 0.5*sqrt(dx*dx+dy*dy+dz*dz);

}

void camera_lookat(const Point3d& min, const Point3d& max, double aspect)
{
	Point3d up(0, 1, 0);
	double fovy = 60.0;

	Point3d at = (max + min) / 2.0;         // look at the center of the bbox
	double radius = (max - at).norm();    // radius of a bounding sphere
	double d = 3 * radius / tan(fovy * M_PI /2/ 180.0);

	Point3d from = at;
	from[2] = d;

	double znear = d/6 ;
	double zfar = 10 * d;

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	//for perspective uncomment
	gluPerspective(fovy, aspect, znear, zfar);
//	//for ortho uncomment
/*		const float V = (float)winW / winH;

	if (V >= 1) {
		// wide viewport, use full height
		glOrtho(-V*d , V * d /1, -d / 1, d / 1, -d / 1, d / 1);

	}
	else {
		// tall viewport, use full width
		glOrtho(- d / 1,  d / 1, - d / 1/V,  d / 1/ V, -d / 1, d / 1);
		//ortho(-target_width / 2.0f, target_width / 2.0f, -A / V * target_height / 2.0f, A / V * target_height / 2.0f, ...);
	}
*/


	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	//gluLookAt(0, 0, 500.0,
	//	0, 0, 0,
	//	0, 1, 0);
	//for perspective uncomment
	/**/gluLookAt(from[0], from[1], from[2],
		at[0], at[1], at[2],
		up[0], up[1], up[2]);
}
void viewing(int W, int H)								//Window resize function, sets up viewing parameters (GLUT callback function)
{
	winW = W;
	winH = H;


	glViewport(0, 0, W, H);
	//
	camera_lookat(Point3d(Xmin, Ymin, Zmin), Point3d(Xmax, Ymax, Zmax), (float)winW / winH);

	m_ball.tbReshape(winW, winH);
	glutPostRedisplay();




}
void reset()
{

	m_ball.tbInit(GLUT_LEFT_BUTTON);
	viewing(winW, winH);


}
void
	keyboard(unsigned char key, int x, int y)
{
	switch (key) {
	case 'h':
		printf("help\n\n");
		printf("f            -  Filled\n");
		printf("w            -  Wireframe\n");
		printf("backspace    -  Reset\n");
		printf("escape or q  -  Quit\n\n");
		break;
	case 'r':
		reset();
			glutPostRedisplay();
		break;


	case 'f':
		glPolygonMode(GL_FRONT, GL_FILL);
		break;

	case 'w':
		glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
		break;
	case '-':


		glutPostRedisplay();

		break;
	case '+':

		glutPostRedisplay();
		break;
	case '\b':

		break;

	case 'q':
	case 27:
		exit(0);
		break;
	}

	glutPostRedisplay();
}

//font_style=GLUT_BITMAP_HELVETICA_18
//  A pointer to a font style..
//  Fonts supported by GLUT are: GLUT_BITMAP_8_BY_13,
//  GLUT_BITMAP_9_BY_15, GLUT_BITMAP_TIMES_ROMAN_10,
//  GLUT_BITMAP_TIMES_ROMAN_24, GLUT_BITMAP_HELVETICA_10,
//  GLUT_BITMAP_HELVETICA_12, and GLUT_BITMAP_HELVETICA_18.
GLvoid *font_style = GLUT_BITMAP_HELVETICA_18;
//-------------------------------------------------------------------------
//  Draws a string at the specified coordinates.
//-------------------------------------------------------------------------
void printw (float x, float y, float z, char* format, ...)
{
	va_list args;   //  Variable argument list
	int len;        // String length
	int i;          //  Iterator
	char * text;    // Text

	//  Initialize a variable argument list
	va_start(args, format);

	//  Return the number of characters in the string referenced the list of arguments.
	// _vscprintf doesn't count terminating '\0' (that's why +1)
	len = _vscprintf(format, args) + 1;

	//  Allocate memory for a string of the specified size
	text = (char *) malloc(len * sizeof(char));

	//  Write formatted output using a pointer to the list of arguments
	vsprintf_s(text, len, format, args);

	//  End using variable argument list
	va_end(args);

	//  Specify the raster position for pixel operations.
	glRasterPos3f (x, y, z);

	//  Draw the characters one by one
	for (i = 0; text[i] != '\0'; i++)
		glutBitmapCharacter(font_style, text[i]);

	//  Free the allocated memory for the string
	free(text);
}
void rainbow(float value,float& R,float& G,float& B)	//Maps a scalar in [0,1] to a color using the rainbow colormap
{
	const float dx=0.8f;

	value = (6-2*dx)*value+dx;
	R = FXMAX(0.0f,(3-(float)fabs(value-4)-(float)fabs(value-5))/2);
	G = FXMAX(0.0f,(4-(float)fabs(value-2)-(float)fabs(value-4))/2);
	B =FXMAX(0.0f,(3-(float)fabs(value-1)-(float)fabs(value-2))/2);
}
double roundwell(float x)
{

	int negpower=false;
	int sign=1;
	if (x<0)sign=-1;
	int po= log10f(fabs(x));
	if (po<0) negpower=true;

	//double partnoten=abs(x)-pow(10.0,po-1);
	double part=fabs(x)-int(fabs(x));
	double k1=0;
	//double k1=ceilf(fpart1000);
	if (part>0.986)
	{
		k1=ceilf(part);

	}
	if (part<0.0001)
	{
		//sign=0;
		part=0.0;

	}
	double toadd=0;
	if(k1!=0)
	{
		toadd=k1;
	}else
	{
		toadd=part;
	}
	int minorpo=0;
	if (po>0)
	{
		minorpo=0;
	}
	return sign*(int(fabs(x))+(toadd)*pow(10.0,fabs(minorpo)));

}


Point3d computeNormal(const Point3d& p)					//Given a point p on the function's domain, computes the normal
{														//of the graph of the function at p
	Point3d pr(p.x+dx,p.y,f(p.x+dx,p.y));				//For this, we compute four normals of the triangles formed by p and neighbor
	Point3d pl(p.x-dx,p.y,f(p.x-dx,p.y));				//grid points (pr,pl,pu,pd), and next average them.
	Point3d pu(p.x,p.y+dy,f(p.x,p.y+dy));
	Point3d pd(p.x,p.y-dy,f(p.x,p.y-dy));

	Point3d n1 = (pr-p).cross(pu-p); n1.normalize();	//Compute the four normals of the above triangles
	Point3d n2 = (pu-p).cross(pl-p); n2.normalize();
	Point3d n3 = (pl-p).cross(pd-p); n3.normalize();
	Point3d n4 = (pd-p).cross(pr-p); n4.normalize();

	Point3d n = n1+n2+n3+n4;							//Compute the average normal
	n.normalize();										//Normalize the result, since it should be unit length

	return n;
}

void onmotion(int x, int y)
{


	m_ball.tbMotion(x,y);
	glutPostRedisplay();
}
void onmouse(int butt, int state, int x, int y)
{


	m_ball.tbMouse(butt,state,x,y);

}

void Color_Bar ()
{
	int i;
	GLint viewport[4];
	glGetIntegerv(GL_VIEWPORT,viewport);
	static float col[256][3];
	for (int i=0;i<256;i++)
	{
		float tmp, r,g,b;
		tmp=(float)i/255.0;
		rainbow(tmp,r,g,b);
		col[i][0]=r;
		col[i][1]=g;
		col[i][2]=b;
	}

	// Set up coordinate system to position color bar near bottom of window.
	//glPushMatrix();
	//glPushAttrib(GL_ALL_ATTRIB_BITS);
	glPushMatrix();

	glLoadIdentity();
	glMatrixMode (GL_PROJECTION);
	glPushMatrix();
	glLoadIdentity ();
	glOrtho (viewport[0], viewport[2], viewport[1], viewport[3], -1, 1);

	glPushAttrib(GL_ALL_ATTRIB_BITS);
	//glDisable(GL_LIGHTING);
	glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
	// Use Quad strips to make color bar.

	glBegin (GL_QUAD_STRIP);
	for (i = 0; i <= 255; i++)  {
		glColor3fv  (col[i]);

		glVertex2i (viewport[2]-65-4*9,viewport[3]/4+i*(viewport[3])/(512-128));
		glVertex2i (20+viewport[2]-65-4*9,viewport[3]/4+i*(viewport[3])/(512-128));
	}
	glEnd ();



	//Ticks
	glLineWidth(3);
	glBegin(GL_LINES);
	for (int i = 0; i <= N; i++)  {
		//glColor3fv  (col[i]);
		glColor3fv  (col[i*255/(N)]);
		float showval=i*(Zmax-Zmin)/N;
		glVertex2i (viewport[2]-58+12-4*9,viewport[3]/4+1+i*253/N*(viewport[3])/(512-128));
		glVertex2i (10+viewport[2]-58+11-4*9,viewport[3]/4+1+i*253/N*(viewport[3])/(512-128));


	}
	glEnd();
	// Label ends of color bar.
	int porange=fabs(log10f(fabs(Zmax-Zmin)));
	glColor3ub(0,0,0);
	for (int i = 0; i <= N; i++)  {
		//glColor3fv  (col[i]);
		float showval=Zmin+i*(Zmax-Zmin)/N;

		double rounded=roundwell(showval);
		rounded=rounded/pow(10.0,porange);
		printw((float)10.0+viewport[2]-58+8-4*8,viewport[3]/4-3+i*255/(N)*(viewport[3])/(512-128),0,"%.2lf",rounded);

	}
	if (porange>2)
	{

	font_style = GLUT_BITMAP_HELVETICA_12;
	printw((float)10.0+viewport[2]-58+1-3*8,viewport[3]/4+13+257*(viewport[3])/(512-128),0,"x");
	font_style = GLUT_BITMAP_HELVETICA_18;
	printw((float)10.0+viewport[2]-58+8-3*8,viewport[3]/4+13+257*(viewport[3])/(512-128),0,"10");
	font_style = GLUT_BITMAP_HELVETICA_12;
	printw((float)10.0+viewport[2]-58+4,viewport[3]/4+18+257*(viewport[3])/(512-128),0,"%d",porange);
	font_style = GLUT_BITMAP_HELVETICA_18;
}
	//glEnable(GL_LIGHTING);
	glPopAttrib();
	glColor3f (1, 1, 1);
	glPopMatrix();
	glMatrixMode(GL_MODELVIEW);
	glPopMatrix();
	//bitmap_output (-5, 7, 0, "Min_H", GLUT_BITMAP_9_BY_15);
	//bitmap_output (95, 7, 0, "Max_H", GLUT_BITMAP_9_BY_15);
	//glPopMatrix();

}
void drawaxis()
{
	glPushMatrix();
	glColor3f(0, 0, 1);
	glBegin(GL_LINES);
	glVertex3f(0, 0, 0);
	glVertex3f(0, 0, 1);
	glEnd();
	glColor3f(0, 1, 0);
	glBegin(GL_LINES);
	glVertex3f(0, 0, 0);
	glVertex3f(0, 1, 0);
	glEnd();
	glColor3f(1, 0, 0);
	glBegin(GL_LINES);
	glVertex3f(0, 0, 0);
	glVertex3f(1, 0, 0);
	glEnd();
	glPopMatrix();
}





void draw()												//Render the height plot (GLUT callback function)
{
static	float r = getboundingR();

	glClearColor(1,1,1,1);								//1. Clear the frame and depth buffers
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	glEnable(GL_DEPTH_TEST);

	glEnable(GL_NORMALIZE);								//2. Ask OpenGL to automatically normalize normal-vectors when we scale the model
	//   This is required to get correct shading for various model scales.
		glClearDepth(1.0f);                   // Set background depth to farthest
		glEnable(GL_DEPTH_TEST);   // Enable depth testing for z-culling
		glDepthFunc(GL_LEQUAL);    // Set the type of depth-test
		glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);  // Nice perspective corrections


	glPushMatrix();
	glLoadIdentity();
	glTranslatef(-c_x, -c_y, -c_z);
	glLineWidth(3);
	drawaxis();
	glPopMatrix();
	glLineWidth(1);

	glPushMatrix();
		glLoadIdentity;



	m_ball.tbMatrix();
	drawaxis();


	glTranslatef(-c_x, -c_y, -c_z);

	glColor3f(0,0,0);
	//vxatavt sferos
	glPushMatrix();
		glTranslatef(c_x, c_y, c_z);
		glPointSize(9.0);
		glBegin(GL_POINTS);
		glVertex3f(0.0, 0.0, 0.0);
		glEnd();
		glColor3f(0, 0, 0);
		glutWireSphere(r,20,20);
	glPopMatrix();

//vanacvlebs (0,0,0)_shi centrs da vxatavt danarchen monacemebs
	//glTranslatef(-c_x, -c_y, -c_z);
	//glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
glBegin(GL_QUADS);
	for(float x=Xmin;x<=Xmax-dx;x+=dx)					//2. Render the height plot as a set of quads
		for(float y=Ymin;y<=Ymax-dy;y+=dy)
		{

			float val=f(x,y);
			Point3d p1(x,y,val);
			Point3d n1=computeNormal(p1);
			float r,g,b;
			float scaledval=(val-Zmin)/(Zmax-Zmin);
			rainbow(scaledval,r,g,b);
			glColor3f(r,g,b);

			glNormal3fv(n1);
			glVertex3f(x,y,val);
			glVertex3f(x+dx,y, f(x+dx, y));
			glVertex3f(x+dx,y+dy, f(x+dx, y+dy));
			glVertex3f(x,y+dy, f(x, y+dy));



		}

		glEnd();
		glPopMatrix();
	//vxatavt ferebis shkalas;
			Color_Bar();
	//vushvebt yvelafers ekranze
			glFlush();
			glutSwapBuffers();									//3. Rendering ready, ask GLUT to show the back buffer
}







int main(int argc,char* argv[])							//Main program
{
	glutInit(&argc, argv);								//1. Initialize the GLUT toolkit
	glutInitDisplayMode(GLUT_DEPTH | GLUT_DOUBLE | GLUT_RGB | GLUT_STENCIL);			//2. Ask GLUT to create next windows with a RGB framebuffer and a Z-buffer too
	glutInitWindowSize(winW,winH);							//3. Tell GLUT how large are the windows we want to create next
	glutCreateWindow("1. Simple graph");					//4. Create our window
	calcZminmax();
	m_ball.tbInit(GLUT_LEFT_BUTTON);

	//eye_z=c_z-camDistance();

	glutMotionFunc(onmotion);
	glutMouseFunc(onmouse);
	glutKeyboardFunc(keyboard);
	glutDisplayFunc(draw);							//5. Add a drawing callback to the window
	glutReshapeFunc(viewing);							//6. Add a resize callback to the window
	glutMainLoop();										//7. Start the event loop that displays the graph and handles window-resize events

	return 0;
}




